package target

import (
	"encoding/json"
	"git.loafle.net/overflow/commons_go/model/timestamp"
	"git.loafle.net/overflow/overflow_proxy_service/proxy/member"
	"git.loafle.net/overflow/overflow_proxy_service/proxy"

	"fmt"
)

type Target struct {
	Id json.Number 		`json:"id,Number,omitempty"`
	Ip int64		`json:"ip,omitempty"`
	Port int		`json:"port,omitempty"`
	TargetType string	`json:"targetType,omitempty"`
	VendorName	string	`json:"vendorName,omitempty"`
	Kinds	string		`json:"kinds,omitempty"`
	Version string		`json:"version,omitempty"`
	CreateDate timestamp.Timestamp	`json:"createDate,omitempty"`
	PortType string		`json:"portType,omitempty"`
	Member *member.Member	`json:"member,omitempty"`

}

type TargetService struct {

}

func NewTargetService() *TargetService {
	return &TargetService{}
}

func (t *TargetService)GetModel() interface{} {
	return &Target{}
}

func (t *TargetService)List(tm *Target) string {


	//FIXME:: Test hard code
	tm.Member.Id = "1"

	bytes, err := json.Marshal(tm)

	if err != nil {
		return ""
	}

	m := make(map[string]string)
	m["com.loafle.overflow.target.model.Target"] = string(bytes)

	out := proxy.InvokeDB("target", "findAll", m)


	return out;
}

func (t *TargetService)Create(tm *Target) string {

	bytes, err := json.Marshal(tm)

	if err != nil {
		return ""
	}

	m := make(map[string]string)
	m["com.loafle.overflow.target.model.Target"] = string(bytes)

	out := proxy.InvokeDB("target", "create", m)


	return out;
}

func (t *TargetService)CreateAll(tmlist *[]*Target) string {



	outlist := make([]string, 0)
	for _, ttt := range *tmlist {
		out := t.Create(ttt)
		outlist = append(outlist, out)
	}

	bytes,err := json.Marshal(outlist)

	if err != nil {
		return ""
	}

	return string(bytes)

}

func (t *TargetService)CreateListTT(tmlist *[]*Target) string {
	bytes, err := json.Marshal(tmlist)

	if err != nil {
		return ""
	}

	m := make(map[string]string)
	m["java.util.List"] = string(bytes)

	fmt.Println(string(bytes))
	out := proxy.InvokeDB("target", "createAll", m)
	//
	//
	return out;
	//return ""
}